<?php
/*

 $Id: pointer.php,v 1.12 2003/10/23 22:05:26 vollmerk Exp $
 $Source: /a1/cvsroot/maint/docs/pointer.php,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*!
	@header Forward and Reverse Pointer document
	Document that hold actions relating to forward and reverse pointers

*/

/* Start House Keeping */

	require("../modules/config.php");

	// make sure they are supposed to be here
        if (!check_session()) { logout(); }
	
	setup_user_environment($action, $zone_id);

	$conf['script'] = "pointer.php";
/* End House Keeping */

// Create needed objects
$pointer = new Pointer($pointer_id);
show_template('header');

echo "<p class=\"header2\">Managing Forward/Reverse Pointers</p>";

/*********************
     WORK IF BLOCK
*********************/

/*!
	@funciton update_pointer
	@discussion updates a single pointer, amazing!
*/
if ($action == 'update_pointer') {

	if ($user->has_access($pointer->zone) < 50) {
		$conf['ui']->show_access_denied();
		$conf['error']->error_state = true;
	}

	if (!$ttl) { $ttl = $conf['default_pointer_ttl']; }

        // Create the objects we are going to need
        $ip = new IP(0);

        // First make sure we have valid fields
        if (!$ip->is_dotted_quad($ip_addr)) {
                $conf['error']->add_error('ip_addr', "Invalid IP Address Entered");
        }

        if (!preg_match("/^[\w\-\d]+\.[\w\-\d]+/", $hostname)) {
                $conf['error']->add_error('hostname', "Invalid Hostname Entered");
        }

        if (!is_numeric($ttl)) {
                $conf['error']->add_error('ttl',"Time to live must be numeric");
        }
	
	// Checks if it's a reverse pointer
	if ($pointer->type === 'reverse') { 
		// Now we need to make sure they actually own the IP address (we don't care about the hostname)
	        // we also need to make sure it isn't in a dynamic range...
	        $sql = "SELECT id FROM ranges WHERE start<='$ip_int' AND end>='$ip_int'";
	        $db_results = mysql_query($sql, $conf['dbh']);

	        $results = mysql_fetch_object($db_results);
	        $test_range = new Range($results->id);

	        if ($test_range->type == 'dynamic' or $test_range->type == 'ddns') {
	                $conf['error']->add_error('ip_addr',"$ip_addr is a dynamic address, you must use a static address");
	        } // test for dyanmic range

		// If they arne't an admin the IP must be in this zone
	        if (!$test_range->has_zone($conf['zone']->id) && !$user->is_admin) {
	                $conf['error']->add_error('ip_addr', "$ip_addr is not in the current zone");
	        }

	        // Check to see if there is a A record with this ip, or another pointer with this ip
	        $pointer->check_ip($ip_int);

	} // if pointer reverse

	// Forward pointer checks
	else { 
		//For forward pointers (domain --> IP) we just check to make sure domain is under their control
	        $data = split_hostname($hostname);
	        $sql = "SELECT id FROM domain WHERE name='$data->domain'";
	        $db_results = mysql_query($sql, $conf['dbh']);

	        $results = mysql_fetch_object($db_results);
	        if (!$conf['zone']->has_domain_access($results->id)) {
			// Now we need to make sure it isn't actually one of their domains
			$domains = $conf['zone']->domains();
			
			foreach($domains as $domain) { 
				if ($domain->name == $hostname) { $found=1; }
			} // end foreach
		
			// If they aren't an admin they can't create pointers for domains that aren't under their control
			if (!$found && !$user->is_admin) { 
		                $conf['error']->add_error('hostname',$conf['zone']->name . " does not have access to " . $data->domain);
			}
	        }

	        // Make sure we don't have a A Record or a CNAME with this hostname
	        // this functions sets the errors in it's self
	        $pointer->check_hostname($data->name,$data->domain,$ip->ip2int($ip_addr));
	} // if pointer forward	


	if (!$conf['error']->error_state) {

		$pointer->update_ip($ip->ip2int($ip_addr));
		$pointer->update_hostname($hostname);
		$pointer->update_status($status);
		$pointer->update_ttl($ttl);
		$pointer->object_history->update($user->username,$comment);

		$conf['ui']->display_confirmation("Pointer Updated", "The $pointer->type pointer has been updated", $conf['web_path'] . "/pointer.php?action=show_pointer&pointer_id=$pointer_id");
	} // if there isn't an error

	else { 

		$action = 'edit_pointer';

	} // if error

} // update_pointer


/*!
	@function create_pointer-forward
	@discussion creates a forward pointer
		    www.domain.com --> IP ADDR
*/
if ($action == 'create_pointer' && $type == 'forward') {

	// Create the objects we are going to need
	$ip = new IP(0);

	if ($user->has_access($conf['zone']->id) < 50) {
		$conf['error']->error_state = true;
		$conf['ui']->show_access_denied(); 
	}

	// First make sure we have valid fields
	if (!$ip->is_dotted_quad($ip_addr)) {
		$conf['error']->add_error('ip_addr', "Invalid IP Address Entered");
	}

	if (!preg_match("/^[\w\-\d]+\.[\w\-\d]+/", $hostname)) {
		$conf['error']->add_error('hostname', "Invalid Hostname Entered");
	}

	if (!is_numeric($ttl)) {
		$conf['error']->add_error('ttl',"Time to live must be numeric");
	}

	//For forward pointers (domain --> IP) we just check to make sure domain is under their control
	$data = split_hostname($hostname);
	$sql = "SELECT id FROM domain WHERE name='$data->domain'";
	$db_results = mysql_query($sql, $conf['dbh']);
	
	$results = mysql_fetch_object($db_results);
	if (!$conf['zone']->has_domain_access($results->id)) {
                // Now we need to make sure it isn't actually one of their domains
                $domains = $conf['zone']->domains();

                foreach($domains as $domain) {
                	if ($domain->name == $hostname) { $found=1; }
                } // end foreach

                if (!$found && !$user->is_admin) {
        	        $conf['error']->add_error('hostname',$conf['zone']->name . " does not have access to this domain");
	        }
	} //end if has_domain_access

	// Make sure we don't have a A Record or a CNAME with this hostname
	// this functions sets the errors in it's self	
	$pointer->check_hostname($data->name,$data->domain,$ip->ip2int($ip_addr));

	if (!$conf['error']->error_state) {

		$pointer_id = $pointer->create_pointer($hostname,$ip->ip2int($ip_addr),$ttl,$type);
		$pointer = new Pointer($pointer_id);
		$pointer->object_history->update($user->username,$comment);
		$conf['ui']->display_confirmation("Pointer Created", "$hostname has been created as a forward pointer to $ip_addr", $conf['web_path'] . "/pointer.php?action=show_pointer&amp;pointer_id=$pointer_id");

	} // no errors!

	else {
		$action = 'show_create_pointer';
		$type = 'forward';
	}


} // create_forward_pointer

/*!
	@function create_reverse_pointer
	@discussion creates a reverse pointer
		    IP ADDR --> www.domain.com
*/
elseif ($action === 'create_pointer' && $type='reverse') {

	// Create the objects we are going to need
	$ip = new IP(0);

	if ($user->has_access($conf['zone']->id) < 50) {
		$conf['error']->error_state = true;
		$conf['ui']->show_access_denied(); 
	}

	$ip_int = $ip->ip2int($ip_addr);

	// First make sure we have valid fields
	if (!$ip->is_dotted_quad($ip_addr)) {
		$conf['error']->add_error('ip_addr', "Invalid IP Address Entered");
	}

	if (!preg_match("/^[\w\-\d]+\.[\w\-\d]+/", $hostname)) {
		$conf['error']->add_error('hostname', "Invalid Hostname Entered");
	}

	if (!is_numeric($ttl)) {
		$conf['error']->add_error('ttl',"Time to live must be numeric");
	}

	// Now we need to make sure they actually own the IP address (we don't care about the hostname)
	// we also need to make sure it isn't in a dynamic range...
	$sql = "SELECT id FROM ranges WHERE start<='$ip_int' AND end>='$ip_int'";
	$db_results = mysql_query($sql, $conf['dbh']);

	$results = mysql_fetch_object($db_results);
	$test_range = new Range($results->id);

	if ($test_range->type == 'dynamic' or $test_range->type == 'ddns') {
		$conf['error']->add_error('ip_addr',"$ip_addr is a dynamic address, you must use a static address");
	} // test for dyanmic range
	
	if (!$test_range->has_zone($conf['zone']->id) && !$user->is_admin) {
		$conf['error']->add_error('ip_addr', "$ip_addr is not in the current zone");
	}

	// Check to see if there is a A record with this ip, or another pointer with this ip
	$pointer->check_ip($ip_int);

	if (!$conf['error']->error_state) {

		$pointer_id = $pointer->create_pointer($hostname,$ip_int,$ttl,$type);
		$pointer = new Pointer($pointer_id);
		$pointer->object_history->update($user->username,$comment);
		$conf['ui']->display_confirmation("Pointer Created", "$ip_addr has been created as a reverse pointer to $hostname", $conf['web_path'] . "/pointer.php?action=show_pointer&amp;pointer_id=$pointer_id");

	} // no errors!

	else {
		$action = 'show_create_pointer';
	}


} // create_reverse_pointer

/*!
	@function delete_pointer
	@discussion delets a forward/reverse pointer
*/
elseif ($action === 'delete_pointer') {

	if ($user->has_access($pointer->zone) >= 50) {
		$pointer->delete($pointer_id);
		$conf['ui']->display_confirmation("Pointer Deleted", "The $pointer->type pointer has been delete", $conf['web_path'] . "/index.php");
	}

	else {
		$conf['ui']->show_access_denied();
	}

} // delete_pointer

/*!
	@function change_status
	@discussion changes the status from enabled --> disabled 
		    or disabled --> enabled
*/
elseif ($action === 'change_status') { 

	if ($user->has_access($pointer->zone) < 50) {
		$conf['error']->error_state = true;
		$conf['ui']->show_access_denied(); 
	}

	if ($user->has_access($pointer->zone)) {
		$pointer->update_status($status);
		$conf['ui']->display_confirmation("Pointer Updated", "The $pointer->type pointer has been $status", $conf['web_path'] . "/pointer.php?action=show_pointers");
	}

} // change_status


/************************
   START DISPLAY BLOCK
************************/

/*!
	@function show_pointers
	@discussion shows all pointers in specified zone
*/
if ($action == 'show_pointers') { 

	if (!$user->view) {
		$user->view = new View("SELECT id FROM pointer WHERE zone='" . $conf['zone']->id . "'");
	}

	if ($sort_type) {
		$user->view->initialize($sort_type,$sort_offset);
	}
	else {
		$user->view->initialize('hostname',$sort_offset);
		
	}

	$pointers = $conf['ui']->get_pointers();
	$total_items = mysql_num_rows(mysql_query($user->view->get_sql(), $conf['dbh']));
	require ($conf['prefix'] . "/templates/show_pointers.inc");

} // show_pointers

/*!
	@function show_pointer
	@discussion shows a single pointer
*/
elseif ($action == 'show_pointer') { 

	require ($conf['prefix'] . "/templates/show_pointer.inc");

} // show_pointer

/*!
	@function edit_pointer
	@discussions shows the template for editing a single pointer
*/
elseif ($action == 'edit_pointer') {
	
	require ($conf['prefix'] . "/templates/show_pointer.inc");

} // edit_pointer

/*!
	@function show_delete_pointer
	@discussion show a confirmation for deleting a pointer
*/
elseif ($action == 'show_delete_pointer') {

	$conf['ui']->show_confirm($conf['web_path'] . "/pointer.php?action=delete_pointer&pointer_id=$pointer_id", "Are you sure you want to delete the following pointer");
	echo "<br /><br />";
	$action = 'show_pointer';
	require($conf['prefix'] . "/templates/show_pointer.inc");

} // show_delete_pointer

/*!
	@function show_create_pointer
	@discussion show form to create a pointer in zone
*/
elseif ($action == 'show_create_pointer') {

	require($conf['prefix'] . "/templates/show_create_pointer.inc");

} // show_create_pointer

show_template('footer');

?>
